#
# Makefile for gnu-like MicroEMACS on Solaris 2.1
#
#
# BROKENSERVER is used to force redraws
#
CDEFS	= -DJAM -DX11 -DSVR4 -DSOL 
DEBUG   = -g
CC    = cc -c -I/usr/openwin/include -I./ -I/usr/openwin/include/X11 -I/usr/include -I/usr/include/sys $(DEBUG)
LIBS = -L$(OPENWINHOME)/lib -lX11 -ldga -lnsl


# implicit compilation rule

objects: $(OBJ)

.c.o:
	$(CC) $(CDEFS) $*.c

# files that can be removed, because they are really just copies

# object file listg
OBJ = alloca.o basic.o buffer.o cinfo.o dir.o dired.o display.o \
    echo.o extend.o file.o fileio.o help.o kbd.o keymap.o \
    line.o macro.o main.o match.o modes.o paragrap.o \
    random.o regex.o region.o re_searc.o search.o spawn.o \
    ttyio.o ttykbd.o version.o window.o word.o unix.o undo.o \
    indent.o crypt.o mouse.o xio.o xkey.o xwin.o 

SRC =  mouse.c xio.c xkey.c xwin.c xmem.c \
    alloca.c basic.c buffer.c cinfo.c dir.c dired.c display.c \
    echo.c extend.c file.c fileio.c help.c kbd.c keymap.c \
    line.c macro.c main.c match.c modes.c paragrap.c \
    random.c regex.c region.c re_searc.c search.c spawn.c \
    ttyio.c ttykbd.c version.c window.c word.c unix.c undo.c indent.c \
    crypt.c 


xnot: $(OBJ)
	cc -o $(DEBUG) xnot $(OBJ) $(LIBS)


xnotalrm: xnotalrm.o
	cc -o xnotalrm xnotalrm.o $(LIBS)

xnotalrm.o: xnotalrm.c
	$(CC) $(CDEFS) xnotalrm.c

all: xnot xnotalrm
