/*
 *	Termcap terminal file, nothing special, just make it big
 *	enough for windowing systems.
 */

#define	GOSMACS			/* Extended window functions (previous window, 
                                   scroll 1 line forw/back) */

/* Curious curious; MicroSoft windows is much faster redrawing
* all text then it is in computing and doing 'scrolls' of text lines (ie blits)
* Code originally for a VAX; perhaps instruction set is different. In anycase, 
* on Windows we just redraw any damaged line. On most X servers
* the overhead of network traffic is more significant than the work to
* compute scrollable areas. Note the hack for the broken X server (ie
* clipping doesn't work with CopyArea).
*/
#if defined(MSW) || defined(BROKENSERVER)
#  define WINDOW_IO		/* Fast window system output if fast display */
#endif

#ifndef WINDOW_IO		/* Dynamic redisplay code, not useful */
# define GOSLING                /* with WINDOW_IO since WINDOW_IO presumed to
                                /* be very fast.  Code in display.c and */
                                /* *io.c gets turned on/off with this */

#endif


#ifdef CURSES
# undef GOSLING
#endif

#ifndef JAM  /* moved to jam.h */
# define NROW   25                      /* Rows.                        */
# define NCOL	80			/* Columns.			*/
#endif


#define	MOVE_STANDOUT			/* don't move in standout mode	*/
/* #define	STANDOUT_GLITCH		/* possible standout glitch	*/
#define XKEYS

#define KFIRST	K00
#define KHOME	K00
#define KDOWN	K01
#define	KUP	K02
#define	KLEFT	K03
#define	KRIGHT	K04
#define	KPGUP	K05
#define	KPGDN	K06
#define	KEND	K07
#define	KDELETE	K08
#define	KINSERT	K09
#define KCLEFT	K0A
#define KCRIGHT	K0B
#define KCPGUP	K0C
#define KCPGDN	K0D
#define KCHOME	K0E
#define KCEND	K0F

#define	KF1	K10
#define KF2	K11
#define KF3	K12
#define KF4	K13
#define KF5	K14
#define KF6	K15
#define KF7	K16
#define KF8	K17
#define	KF9	K18
#define KF10	K19
#define	KSF1	K1A
#define	KSF2	K1B
#define	KSF3	K1C
#define	KSF4	K1D
#define	KSF5	K1E
#define	KSF6	K1F
#define	KSF7	K20
#define	KSF8	K21
#define	KSF9	K22
#define	KSF10	K23
#define KCF1	K24
#define KCF2	K25
#define KCF3	K26
#define KCF4	K27
#define KCF5	K28
#define KCF6	K29
#define KCF7	K2A
#define KCF8	K2B
#define KCF9	K2C
#define KCF10	K2D
#ifndef JAM
# define KLAST	K2D
#endif

#ifdef JAM        /* not in same order, grouped by number not modifier */
# define KF11   K2E
# define KSF11  K2F
# define KCF11  K30
# define KF12   K31
# define KSF12  K32
# define KCF12  K33

# define KPNUMLK K34  /* keypad keys */
# define KPDIV  K35
# define KPMUL  K36
# define KPSUB  K37
# define KP7    K38
# define KP8    K39
# define KP9    K40
# define KPADD  K41
# define KP4    K42
# define KP5    K43
# define KP6    K44
# define KP1    K45
# define KP2    K46
# define KP3    K47
# define KPENTER K48
# define KP0    K49
# define KPDEL  K50

# define KMF1	K51
# define KMF2	K52
# define KMF3	K53
# define KMF4	K54
# define KMF5	K55
# define KMF6	K56
# define KMF7	K57
# define KMF8	K58
# define KMF9	K59
# define KMF10	K60
# define KMF11	K61
# define KMF12	K62
# define KCSF1	K63
# define KCSF2	K64
# define KCSF3	K65
# define KCSF4	K66
# define KCSF5	K67
# define KCSF6	K68
# define KCSF7	K69
# define KCSF8	K70
# define KCSF9	K71
# define KCSF10	K72
# define KCSF11	K73
# define KCSF12	K74
# define KEXTEND K75     /* special non-keyboard key (JAM) */
# define KFIND   K76
# define KSELECT K77
# define KSFIND  K78
# define KSSELECT K79
# define KLAST	 K79
#endif

#define	NFUND_XMAPS	1
#define	FUND_XMAPS	{KFIRST,KLAST,ibm_keys,(KEYMAP*)NULL}
extern	int (*(ibm_keys[]))(); /* should be FN ibmkeys[], but not defined yet */
/*
 * Extra map segments for extra modes -- just use fundamental mode segments
 */
#define	DIRED_XMAPS	FUND_XMAPS
#define	NDIRED_XMAPS	NFUND_XMAPS

#define	BUFFERL_XMAPS	FUND_XMAPS
#define	NBUFFERL_XMAPS	NFUND_XMAPS
